#include "wtypes.h"
#include "CONFIG.h"

char *_locale[_NML];
char *_localecoms[COMNR];
char *_localeflags[FLAGNR];
char *_localeuflags[UFLAGNR];
extern struct _wconfig _WConfig;
extern char *home;
char *actlang;

char _UFlags[UFLAGNR][5]={"{f}",
                          "{a}",
                          "{F}",
                          "{A}",
                          "{uf}",
                          "{ua}",
                          "{uF}",
                          "{uA}",
                          "{fE}",
                          "{aE}",
                          "{FE}",
                          "{AE}",
                          "{ufE}",
                          "{uaE}",
                          "{uFE}",
                          "{uAE}",
                          "{p}",
                          "{op}",
                          "{lp}",
                          "{rp}",
                          "{Rs}"};

/* Erster Index: Anzahl der Flags fr das Kommando
   Zweiter Index: Offset */

int flaginfo[COMNR][2]={{8,11},
                        {1,1},
                        {5,2},
                        {4,7},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {5,19},
                        {2,24},
                        {0,0},
                        {0,0},
                        {0,0},
                        {0,0},
                        {3,26},
                        {0,0}};

struct _color *_CreateCColor(unsigned char red,unsigned char green,unsigned char blue)
{
  struct _color *tempc;
  tempc=(struct _color *)_allocsafe(sizeof(struct _color));
  if(tempc==NULL) return NULL;
  tempc->red=red;
  tempc->green=green;
  tempc->blue=blue;
  tempc->next=NULL;
  return tempc;
}

void _FreeCColor(struct _color *tempc)
{
  if(tempc!=NULL) _freesafe(tempc);
}

int _FPutChar(unsigned char value,FILE *fp)
{
  int x;
  x=fputc(value,fp);
  if(x!=EOF) return 1;
  printf("fehler bei FPutChar\n");
  return 0;
}

int _FPutInt(unsigned int value,FILE *fp)
{
  int x;
  x=fputc(value>>8,fp);
  if(x==EOF) return 0;
  x=fputc(value&0xff,fp);
  if(x==EOF) return 1;
  return 2;
}

int _FPutLong(unsigned long value,FILE *fp)
{
  int x;
  x=fputc((value&0xff000000)>>24,fp);
  if(x==EOF) return 0;
  x=fputc((value&0xff0000)>>16,fp);
  if(x==EOF) return 1;
  x=fputc((value&0xff00)>>8,fp);
  if(x==EOF) return 2;
  x=fputc(value&0xff,fp);
  if(x==EOF) return 3;
  return 4;
}

int _FPutString(char *string,FILE *fp)
{
  int x;
  x=fputs(string,fp);
  if(x==EOF) return -1;
  return strlen(string);
}

unsigned char _FGetChar(long *error,FILE *fp)
{
  int x;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 0;
  }
  return (unsigned char) x;
}

unsigned short _FGetInt(long *error,FILE *fp)
{
  int x;
  unsigned int a;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 0;
  }
  a=((unsigned int)x)*0x100;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 1;
  }
  a+=(unsigned int)x;
  return a;
}

unsigned long _FGetLong(long *error,FILE *fp)
{
  int x;
  unsigned long a;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 0;
  }
  a=((unsigned int)x)*0x1000000;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 1;
  }
  a+=((unsigned int)x)*0x10000;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 2;
  }
  a+=((unsigned int)x)*0x100;
  x=fgetc(fp);
  if(x==EOF) {
    (*error)++;
    return 3;
  }
  a+=(unsigned int)x;
  return a;
}

char *_FGetString(int count,FILE *fp)
{
  unsigned char *tstr,*tstr2;
  int ch;
  long x;
  long size;
  if(count==-1) {
    /* lesen bis NULL-Byte */
    size=1024;
    tstr=(char*)_allocsafe(size);
    x=0;
    do {
      ch=fgetc(fp);
      if(ch!=EOF) {
        tstr[x++]=(unsigned char)ch;
      } else {
        tstr[x++]=0;
        break;
      }
      if(x==size) {
        size*=2;
        tstr2=(char*)_allocsafe(size);
        if(tstr2==NULL) break;
        strcpy(tstr2,tstr);
        _freesafe(tstr);
        tstr=tstr2;
      }
    } while(ch!=0);
  } else {
    tstr=(char*)_allocsafe(count+1);
    if(tstr!=NULL) {
      for(x=0;x<count;x++) {
        ch=fgetc(fp);
        tstr[x]=(unsigned char)ch;
      }
      tstr[count]=0;
    }
  }
  return tstr;
}

int _FindChunk(char *str,FILE *fp)
{
  int x,len,y,ic1,ic2;
  fseek(fp,0,SEEK_SET);
  len=strlen(str);
  y=0,x=0;
  while(x<len) {
    if(x==-1) {
      x=0;
    } else {
      y=fgetc(fp);
      if(y==EOF) return 1;
    }
    ic1=y;
    ic2=(int)str[x];
    if(ic1==ic2) {
      x++;
    } else {
      if(x!=0) {
        x=-1;
      }
    }
  }
  return 0;
}

int ParseChunk(FILE *fp)
{
  /* 0 kein Fehler
     1 kein gltiger Chunk
     2 Dateiende
     3 Fehler */
  int returnvalue,y,x;
  unsigned char red,green,blue;
  struct _buttondef button;
  struct _pathdef path;
  struct _filetypedef filetype,*tempft,*tempft1;
  struct _hotkeydef hotkey,*temphk,*temphk1;
  char *tstr,*chunkname;
  int len,slen;
  long error;

  error=0;
  returnvalue=0;
  chunkname=_FGetString(4,fp);
  if(strcmp("GLBL",chunkname)==0) {
    len=_FGetLong(&error,fp);
    _WConfig.colors=_FGetInt(&error,fp);
    len-=2;
    while(len>0) {
      red=_FGetChar(&error,fp);
      green=_FGetChar(&error,fp);
      blue=_FGetChar(&error,fp);
      if(_CreateConfigColor(red,green,blue)!=0) {
        returnvalue=3;
	break;
      }
      len-=3;
    }
  } else if(strcmp("LANG",chunkname)==0) {
    len=_FGetLong(&error,fp);
    if(error!=0) {
      returnvalue=2;
    }
    tstr=_FGetString(len,fp);
    _WConfig.lang=tstr;
  } else if(strcmp("COLD",chunkname)==0) {
    len=_FGetLong(&error,fp);
    _WConfig.statusbarfg=_FGetInt(&error,fp);
    _WConfig.statusbarbg=_FGetInt(&error,fp);
    _WConfig.sel_lvbfg=_FGetInt(&error,fp);
    _WConfig.sel_lvbbg=_FGetInt(&error,fp);
    _WConfig.unsel_lvbfg=_FGetInt(&error,fp);
    _WConfig.unsel_lvbbg=_FGetInt(&error,fp);
    _WConfig.sel_dirfg=_FGetInt(&error,fp);
    _WConfig.sel_dirbg=_FGetInt(&error,fp);
    _WConfig.unsel_dirfg=_FGetInt(&error,fp);
    _WConfig.unsel_dirbg=_FGetInt(&error,fp);
    _WConfig.sel_filefg=_FGetInt(&error,fp);
    _WConfig.sel_filebg=_FGetInt(&error,fp);
    _WConfig.unsel_filefg=_FGetInt(&error,fp);
    _WConfig.unsel_filebg=_FGetInt(&error,fp);
    _WConfig.clockbarfg=_FGetInt(&error,fp);
    _WConfig.clockbarbg=_FGetInt(&error,fp);
    _WConfig.requestfg=_FGetInt(&error,fp);
    _WConfig.requestbg=_FGetInt(&error,fp);
    _WConfig.sel_pathfg=_FGetInt(&error,fp);
    _WConfig.sel_pathbg=_FGetInt(&error,fp);
    _WConfig.unsel_pathfg=_FGetInt(&error,fp);
    _WConfig.unsel_pathbg=_FGetInt(&error,fp);
    len-=22*2;
    if(len>0) {
      /* da gibts noch Informationen, die ich nicht auswerten kann.
         damit's weiter geht, diesen bereich berspringen */
      fseek(fp,len,SEEK_CUR);
    }
    if(error!=0) {
      returnvalue=2;
    }
  } else if(strcmp("LDEF",chunkname)==0) {
    len=_FGetLong(&error,fp);
    _WConfig.leftvbar_left=_FGetChar(&error,fp);
    _WConfig.lefthbar_top=_FGetChar(&error,fp);
    _WConfig.lefthbar_height=_FGetInt(&error,fp);
    _WConfig.leftvbar_width=_FGetInt(&error,fp);
    _WConfig.rightvbar_left=_FGetChar(&error,fp);
    _WConfig.righthbar_top=_FGetChar(&error,fp);
    _WConfig.righthbar_height=_FGetInt(&error,fp);
    _WConfig.rightvbar_width=_FGetInt(&error,fp);
    _WConfig.numxbuttons=_FGetChar(&error,fp);
    _WConfig.numybuttons=_FGetChar(&error,fp);
    len-=6+4*2;
    if(len>0) {
      fseek(fp,len,SEEK_CUR);
    }
    if(error!=0) {
      returnvalue=2;
    }
  } else if(strcmp("DIRS",chunkname)==0) {
    len=_FGetLong(&error,fp);
    slen=_FGetLong(&error,fp);
    tstr=_FGetString(slen,fp);
    _WConfig.ldir=tstr;
    len-=slen+4;
    slen=_FGetLong(&error,fp);
    tstr=_FGetString(slen,fp);
    _WConfig.rdir=tstr;
    len-=slen+4;
    if(len>0) {
      fseek(fp,len,SEEK_CUR);
    }
    if(error!=0) {
      returnvalue=2;
    }
  } else if(strcmp("BUTD",chunkname)==0) {
    len=_FGetLong(&error,fp);
    while(len>0) {
      button.check=_FGetChar(&error,fp);
      len--;
      y=_FGetLong(&error,fp);
      len-=4;
      button.text=_FGetString(y,fp);
      len-=y;
      button.fg=_FGetInt(&error,fp);
      button.bg=_FGetInt(&error,fp);
      button.shortkey=_FGetLong(&error,fp);
      button.mods=_FGetInt(&error,fp);
      button.comnr=_FGetLong(&error,fp);
      button.flag1=_FGetLong(&error,fp);
      button.flag2=_FGetLong(&error,fp);
      len-=22;
      y=_FGetLong(&error,fp);
      len-=4;
      button.usercom=_FGetString(y,fp);
      len-=y;
      if(_CreateConfigButton(button.check,
                             button.text,
			     button.fg,
			     button.bg,
			     button.shortkey,
			     button.mods,
			     button.comnr,
			     button.flag1,
			     button.flag2,
			     button.usercom)!=0) {
        returnvalue=3;
      }
      _freesafe(button.text);
      _freesafe(button.usercom);
    }
    if(error!=0) {
      returnvalue=2;
    }
  } else if(strcmp("PATD",chunkname)==0) {
    len=_FGetLong(&error,fp);
    while(len>0) {
      path.check=_FGetChar(&error,fp);
      len--;
      y=_FGetLong(&error,fp);
      len-=4;
      path.text=_FGetString(y,fp);
      len-=y;
      path.fg=_FGetInt(&error,fp);
      path.bg=_FGetInt(&error,fp);
      path.shortkey=_FGetLong(&error,fp);
      path.mods=_FGetInt(&error,fp);
      len-=10;
      y=_FGetLong(&error,fp);
      len-=4;
      path.path=_FGetString(y,fp);
      len-=y;
      if(_CreateConfigPath(path.check,
                           path.text,
			   path.fg,
			   path.bg,
			   path.shortkey,
			   path.mods,
			   path.path)!=0) {
        returnvalue=3;
      }
      _freesafe(path.text);
      _freesafe(path.path);
    }
  } else if(strcmp("FITY",chunkname)==0) {
    len=_FGetLong(&error,fp);
    tempft=NULL;
    while(len>0) {
      y=_FGetLong(&error,fp);
      len-=4;
      filetype.name=_FGetString(y,fp);
      len-=y;
      y=_FGetLong(&error,fp);
      len-=4;
      filetype.info=_FGetString(y,fp);
      len-=y;
      filetype.comnr=_FGetLong(&error,fp);
      filetype.flag1=_FGetLong(&error,fp);
      filetype.flag2=_FGetLong(&error,fp);
      len-=12;
      y=_FGetLong(&error,fp);
      len-=4;
      filetype.usercom=_FGetString(y,fp);
      len-=y;
      y=_FGetLong(&error,fp);
      len-=4;
      filetype.pattern=_FGetString(y,fp);
      len-=y;
      for(x=0;x<64;x++) {
        filetype.filedesc[x]=(signed short)_FGetInt(&error,fp);
        len-=2;
      }
      filetype.usepattern=_FGetChar(&error,fp);
      filetype.usefiledesc=_FGetChar(&error,fp);
      len-=2;
      tempft1=_DuplicateFiletype(&filetype);
      if(tempft==NULL) {
        _WConfig.firsttype=tempft1;
        tempft=tempft1;
      } else {
        tempft->next=tempft1;
        tempft=tempft1;
      }
      _freesafe(filetype.name);
      _freesafe(filetype.info);
      _freesafe(filetype.usercom);
      _freesafe(filetype.pattern);
    }
  } else if(strcmp("HOTS",chunkname)==0) {
    len=_FGetLong(&error,fp);
    temphk=NULL;
    while(len>0) {
      y=_FGetLong(&error,fp);
      len-=4;
      hotkey.name=_FGetString(y,fp);
      len-=y;
      hotkey.shortkey=_FGetLong(&error,fp);
      hotkey.mods=_FGetInt(&error,fp);
      hotkey.comnr=_FGetLong(&error,fp);
      hotkey.flag1=_FGetLong(&error,fp);
      hotkey.flag2=_FGetLong(&error,fp);
      len-=18;
      y=_FGetLong(&error,fp);
      len-=4;
      hotkey.usercom=_FGetString(y,fp);
      len-=y;
      temphk1=_DuplicateHotkey(&hotkey);
      if(temphk==NULL) {
        _WConfig.firsthotkey=temphk1;
        temphk=temphk1;
      } else {
        temphk->next=temphk1;
        temphk=temphk1;
      }
      _freesafe(hotkey.name);
      _freesafe(hotkey.usercom);
    }
  } else if(strcmp("FONT",chunkname)==0) {
    len=_FGetLong(&error,fp);
    if(error!=0) {
      returnvalue=2;
    }
    tstr=_FGetString(len,fp);
    _freesafe(_WConfig.font);
    _WConfig.font=tstr;
  } else {
    returnvalue=1;
  }
  _freesafe(chunkname);
  return returnvalue;
}

int _ReadConfig(FILE *fp)
{
  char *tstr;
  int x;
  long error;
  error=0;
  _WConfig.first=NULL;
  _WConfig.firstbutton=NULL;
  _WConfig.firstpath=NULL;
  _WConfig.firsttype=NULL;
  _WConfig.firsthotkey=NULL;
  tstr=(char*)_allocsafe(6);
  strcpy(tstr,"fixed");
  _WConfig.font=tstr;
  fseek(fp,0,SEEK_SET);
  tstr=_FGetString(4,fp);
  if(strcmp("FORM",tstr)==0) {
    fseek(fp,4,SEEK_CUR);
    _freesafe(tstr);
    tstr=_FGetString(4,fp);
    if(strcmp("WCFG",tstr)==0) {
      _freesafe(tstr);
      do {
        x=ParseChunk(fp);
      } while(x==0);
    } else {
      _freesafe(tstr);
    }
  } else {
    _freesafe(tstr);
    return 1;
  }
  if(error==0) return 0; else return 1;
}

int _CreateConfigColor(unsigned char red,unsigned char green,unsigned char blue)
{
  struct _color *tempc,*tempc1;
  tempc=(struct _color *)_allocsafe(sizeof(struct _color));
  if(tempc==NULL) return 1;
  tempc->red=red;
  tempc->green=green;
  tempc->blue=blue;
  tempc->next=NULL;
  tempc1=_WConfig.first;
  if(tempc1==NULL) _WConfig.first=tempc;
  else {
    while(tempc1->next!=NULL) tempc1=tempc1->next;
    tempc1->next=tempc;
  }
  return 0;
}

void _FreeAllConfigColor()
{
  struct _color *tempc,*tempc1;
  tempc=_WConfig.first;
  while(tempc!=NULL) {
    tempc1=tempc->next;
    _freesafe(tempc);
    tempc=tempc1;
  }
}

int _CreateConfigPath(char check,char *text,int fg, int bg,unsigned long shortkey,int mods,char *path)
{
  struct _pathdef *tempp,*tempp1;
  char *tstr1,*tstr2;
  tempp=(struct _pathdef *)_allocsafe(sizeof(struct _pathdef));
  if(tempp==NULL) return 1;
  tstr1=(char*)_allocsafe(strlen(text)+1);
  if(tstr1==NULL) return 1;
  tstr2=(char*)_allocsafe(strlen(path)+1);
  if(tstr2==NULL) return 1;
  strcpy(tstr1,text);
  strcpy(tstr2,path);
  tempp->check=check;
  tempp->text=tstr1;
  tempp->fg=fg;
  tempp->bg=bg;
  tempp->shortkey=shortkey;
  tempp->mods=mods;
  tempp->path=tstr2;
  tempp->next=NULL;
  tempp->prev=NULL;
  tempp1=_WConfig.firstpath;
  if(tempp1==NULL) _WConfig.firstpath=tempp;
  else {
    while(tempp1->next!=NULL) tempp1=tempp1->next;
    tempp1->next=tempp;
    tempp->prev=tempp1;
  }
  return 0;
}

struct _pathdef *_CreateNewConfigPath(char check,char *text,int fg, int bg,unsigned long shortkey,int mods,char *path)
{
  struct _pathdef *tempp;
  char *tstr1,*tstr2;
  tempp=(struct _pathdef *)_allocsafe(sizeof(struct _pathdef));
  if(tempp==NULL) return NULL;
  tstr1=(char*)_allocsafe(strlen(text)+1);
  if(tstr1==NULL) return NULL;
  tstr2=(char*)_allocsafe(strlen(path)+1);
  if(tstr2==NULL) return NULL;
  strcpy(tstr1,text);
  strcpy(tstr2,path);
  tempp->check=check;
  tempp->text=tstr1;
  tempp->fg=fg;
  tempp->bg=bg;
  tempp->shortkey=shortkey;
  tempp->mods=mods;
  tempp->path=tstr2;
  tempp->next=NULL;
  tempp->prev=NULL;
  return tempp;
}

int _CreateConfigButton(char check,char *text,int fg, int bg,unsigned long shortkey,int mods,long comnr,long flag1,long flag2,char *usercom)
{
  /* Bedeutung: check:0 = leer
                      1 = benutzt
                text: Beschriftung
                fg: Vordergrundfarbe
                bg: Hintergrundfarbe
                shortkey: Tastaturkrzel
                mods: Beschreibt Modifier: Bit 0 = Alt, Bit 1 = Control
                comnr: Kommandonr. (siehe COMS.H)
                flag1/flag2: Spezielle Flags
                usercom: User-Kommando */
  struct _buttondef *tempb,*tempb1;
  char *tstr1,*tstr2;
  tempb=(struct _buttondef *)_allocsafe(sizeof(struct _buttondef));
  if(tempb==NULL) return 1;
  tstr1=(char*)_allocsafe(strlen(text)+1);
  if(tstr1==NULL) return 1;
  tstr2=(char*)_allocsafe(strlen(usercom)+1);
  if(tstr2==NULL) return 1;
  strcpy(tstr1,text);
  strcpy(tstr2,usercom);
  tempb->check=check;
  tempb->text=tstr1;
  tempb->fg=fg;
  tempb->bg=bg;
  tempb->shortkey=shortkey;
  tempb->mods=mods;
  tempb->comnr=comnr;
  tempb->flag1=flag1;
  tempb->flag2=flag2;
  tempb->usercom=tstr2;
  tempb->next=NULL;
  tempb1=_WConfig.firstbutton;
  if(tempb1==NULL) _WConfig.firstbutton=tempb;
  else {
    while(tempb1->next!=NULL) tempb1=tempb1->next;
    tempb1->next=tempb;
  }
  return 0;
}

struct _buttondef *_CreateNewConfigButton(char check,char *text,int fg, int bg,unsigned long shortkey,int mods,long comnr,long flag1,long flag2,char *usercom)
{
  struct _buttondef *tempb;
  char *tstr1,*tstr2;
  tempb=(struct _buttondef *)_allocsafe(sizeof(struct _buttondef));
  tstr1=(char*)_allocsafe(strlen(text)+1);
  tstr2=(char*)_allocsafe(strlen(usercom)+1);
  strcpy(tstr1,text);
  strcpy(tstr2,usercom);
  tempb->check=check;
  tempb->text=tstr1;
  tempb->fg=fg;
  tempb->bg=bg;
  tempb->shortkey=shortkey;
  tempb->mods=mods;
  tempb->comnr=comnr;
  tempb->flag1=flag1;
  tempb->flag2=flag2;
  tempb->usercom=tstr2;
  tempb->next=NULL;
  return tempb;
}

struct _hotkeydef *_CreateHotkey(char *name,unsigned long shortkey,int mods,long comnr,long flag1,long flag2,char *usercom)
{
  struct _hotkeydef *temphk;
  char *tstr1,*tstr2;
  temphk=(struct _hotkeydef *)_allocsafe(sizeof(struct _hotkeydef));
  if(temphk==NULL) return NULL;
  tstr1=(char*)_allocsafe(strlen(name)+1);
  if(tstr1==NULL) return NULL;
  tstr2=(char*)_allocsafe(strlen(usercom)+1);
  if(tstr2==NULL) return NULL;
  strcpy(tstr1,name);
  strcpy(tstr2,usercom);
  temphk->name=tstr1;
  temphk->shortkey=shortkey;
  temphk->mods=mods;
  temphk->comnr=comnr;
  temphk->flag1=flag1;
  temphk->flag2=flag2;
  temphk->usercom=tstr2;
  temphk->next=NULL;
  return temphk;
}

struct _pathdef *_DuplicateConfigPath(struct _pathdef *sourcep)
{
  struct _pathdef *tempp;
  char *tstr1,*tstr2;
  tempp=(struct _pathdef *)_allocsafe(sizeof(struct _pathdef));
  if(tempp==NULL) return NULL;
  tstr1=(char*)_allocsafe(strlen(sourcep->text)+1);
  if(tstr1==NULL) return NULL;
  tstr2=(char*)_allocsafe(strlen(sourcep->path)+1);
  if(tstr2==NULL) return NULL;
  strcpy(tstr1,sourcep->text);
  strcpy(tstr2,sourcep->path);
  tempp->check=sourcep->check;
  tempp->text=tstr1;
  tempp->fg=sourcep->fg;
  tempp->bg=sourcep->bg;
  tempp->shortkey=sourcep->shortkey;
  tempp->mods=sourcep->mods;
  tempp->path=tstr2;
  tempp->next=NULL;
  tempp->prev=NULL;
  return tempp;
}

struct _buttondef *_DuplicateConfigButton(struct _buttondef *sourceb)
{
  struct _buttondef *tempb;
  char *tstr1,*tstr2;
  tempb=(struct _buttondef *)_allocsafe(sizeof(struct _buttondef));
  if(tempb==NULL) return NULL;
  tstr1=(char*)_allocsafe(strlen(sourceb->text)+1);
  if(tstr1==NULL) return NULL;
  tstr2=(char*)_allocsafe(strlen(sourceb->usercom)+1);
  if(tstr2==NULL) return NULL;
  strcpy(tstr1,sourceb->text);
  strcpy(tstr2,sourceb->usercom);
  tempb->check=sourceb->check;
  tempb->text=tstr1;
  tempb->fg=sourceb->fg;
  tempb->bg=sourceb->bg;
  tempb->shortkey=sourceb->shortkey;
  tempb->mods=sourceb->mods;
  tempb->comnr=sourceb->comnr;
  tempb->flag1=sourceb->flag1;
  tempb->flag2=sourceb->flag2;
  tempb->usercom=tstr2;
  tempb->next=NULL;
  return tempb;
}

struct _hotkeydef *_DuplicateHotkey(struct _hotkeydef *sourcehk)
{
  struct _hotkeydef *temphk;
  char *tstr1,*tstr2;
  temphk=(struct _hotkeydef *)_allocsafe(sizeof(struct _hotkeydef));
  if(temphk==NULL) return NULL;
  tstr1=(char*)_allocsafe(strlen(sourcehk->name)+1);
  if(tstr1==NULL) return NULL;
  tstr2=(char*)_allocsafe(strlen(sourcehk->usercom)+1);
  if(tstr2==NULL) return NULL;
  strcpy(tstr1,sourcehk->name);
  strcpy(tstr2,sourcehk->usercom);
  temphk->name=tstr1;
  temphk->shortkey=sourcehk->shortkey;
  temphk->mods=sourcehk->mods;
  temphk->comnr=sourcehk->comnr;
  temphk->flag1=sourcehk->flag1;
  temphk->flag2=sourcehk->flag2;
  temphk->usercom=tstr2;
  temphk->next=NULL;
  return temphk;
}

struct _filetypedef *_CreateFiletype(char *name,char *info,long comnr,long flag1, long flag2,char *usercom,char *pattern,bool usepattern,bool usefiledesc)
{
  /* fieldesc wird NICHT eingestellt (nur auf -1 gesetzt) */
  struct _filetypedef *tempft;
  char *tstr;
  int x;
  tempft=(struct _filetypedef *)_allocsafe(sizeof(struct _filetypedef));
  if(tempft==NULL) return NULL;
  tstr=(char*)_allocsafe(strlen(name)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,name);
  tempft->name=tstr;
  tstr=(char*)_allocsafe(strlen(info)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,info);
  tempft->info=tstr;
  tempft->comnr=comnr;
  tempft->flag1=flag1;
  tempft->flag2=flag2;
  tstr=(char*)_allocsafe(strlen(usercom)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,usercom);
  tempft->usercom=tstr;
  tstr=(char*)_allocsafe(strlen(pattern)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,pattern);
  tempft->pattern=tstr;
  for(x=0;x<64;x++) {
    tempft->filedesc[x]=-1;
  }
  tempft->usepattern=usepattern;
  tempft->usefiledesc=usefiledesc;
  tempft->next=NULL;
  return tempft;
}

struct _filetypedef *_DuplicateFiletype(struct _filetypedef *sourceft)
{
  struct _filetypedef *tempft;
  char *tstr;
  int x;
  tempft=(struct _filetypedef *)_allocsafe(sizeof(struct _filetypedef));
  if(tempft==NULL) return NULL;
  tstr=(char*)_allocsafe(strlen(sourceft->name)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,sourceft->name);
  tempft->name=tstr;
  tstr=(char*)_allocsafe(strlen(sourceft->info)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,sourceft->info);
  tempft->info=tstr;
  tempft->comnr=sourceft->comnr;
  tempft->flag1=sourceft->flag1;
  tempft->flag2=sourceft->flag2;
  tstr=(char*)_allocsafe(strlen(sourceft->usercom)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,sourceft->usercom);
  tempft->usercom=tstr;
  tstr=(char*)_allocsafe(strlen(sourceft->pattern)+1);
  if(tstr==NULL) return NULL;
  strcpy(tstr,sourceft->pattern);
  tempft->pattern=tstr;
  for(x=0;x<64;x++) {
    tempft->filedesc[x]=sourceft->filedesc[x];
  }
  tempft->usepattern=sourceft->usepattern;
  tempft->usefiledesc=sourceft->usefiledesc;
  tempft->next=NULL;
  return tempft;
}

void _FreeConfigPath(struct _pathdef *tempp)
{
  _freesafe(tempp->text);
  _freesafe(tempp->path);
  _freesafe(tempp);
}

void _FreeFiletype(struct _filetypedef *tempft)
{
  _freesafe(tempft->name);
  _freesafe(tempft->info);
  _freesafe(tempft->usercom);  
  _freesafe(tempft->pattern);
  _freesafe(tempft);
}

void _FreeConfigButton(struct _buttondef *tempb)
{
  _freesafe(tempb->text);
  _freesafe(tempb->usercom);
  _freesafe(tempb);
}

void _FreeHotkey(struct _hotkeydef *temphk)
{
  _freesafe(temphk->name);
  _freesafe(temphk->usercom);
  _freesafe(temphk);
}

void _FreeAllConfigPath()
{
  struct _pathdef *tempp,*tempp1;
  tempp=_WConfig.firstpath;
  while(tempp!=NULL) {
    tempp1=tempp->next;
    _freesafe(tempp->text);
    _freesafe(tempp->path);
    _freesafe(tempp);
    tempp=tempp1;
  }
  _WConfig.firstpath=NULL;
}

void _FreeAllConfigButton()
{
  struct _buttondef *tempb,*tempb1;
  tempb=_WConfig.firstbutton;
  while(tempb!=NULL) {
    tempb1=tempb->next;
    _freesafe(tempb->text);
    _freesafe(tempb->usercom);
    _freesafe(tempb);
    tempb=tempb1;
  }
  _WConfig.firstbutton=NULL;
}

void _FreeAllHotkeys()
{
  struct _hotkeydef *temphk,*temphk1;
  temphk=_WConfig.firsthotkey;
  while(temphk!=NULL) {
    temphk1=temphk->next;
    _freesafe(temphk->name);
    _freesafe(temphk->usercom);
    _freesafe(temphk);
    temphk=temphk1;
  }
  _WConfig.firsthotkey=NULL;
}

int _SetDefaultConfig()
{
  char *tempstr;
  tempstr=(char*)_allocsafe(18);
  _WConfig.lang=tempstr;
  strcpy(tempstr,"english (builtin)");
  tempstr=(char*)_allocsafe(6);
  strcpy(tempstr,"fixed");
  _WConfig.font=tempstr;
  _WConfig.colors=8;
  if(_CreateConfigColor(160,160,160)!=0) return 1;
  if(_CreateConfigColor(0,0,0)!=0) return 1;
  if(_CreateConfigColor(255,255,255)!=0) return 1;
  if(_CreateConfigColor(0,85,187)!=0) return 1;
  if(_CreateConfigColor(204,34,0)!=0) return 1;
  if(_CreateConfigColor(50,180,20)!=0) return 1;
  if(_CreateConfigColor(119,0,119)!=0) return 1;
  if(_CreateConfigColor(238,170,68)!=0) return 1;
  _WConfig.statusbarfg=2;
  _WConfig.statusbarbg=3;
  _WConfig.sel_lvbfg=1;
  _WConfig.sel_lvbbg=4;
  _WConfig.unsel_lvbfg=1;
  _WConfig.unsel_lvbbg=0;
  _WConfig.sel_dirfg=2;
  _WConfig.sel_dirbg=3;
  _WConfig.unsel_dirfg=3;
  _WConfig.unsel_dirbg=0;
  _WConfig.sel_filefg=2;
  _WConfig.sel_filebg=1;
  _WConfig.unsel_filefg=1;
  _WConfig.unsel_filebg=0;
  _WConfig.clockbarfg=1;
  _WConfig.clockbarbg=6;
  _WConfig.requestfg=1;
  _WConfig.requestbg=0;
  _WConfig.sel_pathfg=1;
  _WConfig.sel_pathbg=7;
  _WConfig.unsel_pathfg=1;
  _WConfig.unsel_pathbg=0;
  _WConfig.lefthbar_top=FALSE;
  _WConfig.leftvbar_left=FALSE;
  _WConfig.lefthbar_height=10;
  _WConfig.leftvbar_width=10;
  _WConfig.righthbar_top=FALSE;
  _WConfig.rightvbar_left=TRUE;
  _WConfig.righthbar_height=10;
  _WConfig.rightvbar_width=10;
  _WConfig.numxbuttons=1;
  _WConfig.numybuttons=1;
  tempstr=(char*)_allocsafe(2);
  if(tempstr==NULL) return 1;
  strcpy(tempstr,"");
  _WConfig.ldir=tempstr;
  tempstr=(char*)_allocsafe(2);
  if(tempstr==NULL) return 1;
  strcpy(tempstr,"");
  _WConfig.rdir=tempstr;
  _WConfig.firstbutton=NULL;
  _WConfig.firstpath=NULL;
  _WConfig.firsttype=NULL;
  _WConfig.firsthotkey=NULL;
  if(_CreateConfigButton(1,"Quit",2,4,0,0,QUIT,0,0,"")!=0) return 1;
  if(_CreateConfigButton(0,"",0,0,0,0,0,0,0,"")!=0) return 1;
  if(_CreateConfigPath(0,"",0,0,0,0,"")!=0) return 1;
  return 0;
}

void _CreateLanguage()
{
  char *file,buffer[2048],*tstr;
  FILE *fp;
  int x,len;  /* NumberMainLocales */
  for(x=0;x<_NML;x++) {
    _locale[x]=NULL;
  }
  for(x=0;x<COMNR;x++) {
    _localecoms[x]=NULL;
  }
  for(x=0;x<FLAGNR;x++) {
    _localeflags[x]=NULL;
  }
  for(x=0;x<UFLAGNR;x++) {
    _localeuflags[x]=NULL;
  }
  actlang=NULL;
  _locale[0]="Worker Configuration\0\0";
  _locale[1]="Global Settings\0\0";
  _locale[2]="Colors\0\0";
  _locale[3]="Startup Settings\0\0";
  _locale[4]="Buttons Settings\0\0";
  _locale[5]="Path Settings\0\0";
  _locale[6]="Filetypes\0\0";
  _locale[7]="Save\0\0";
  _locale[8]="Cancel\0\0";
  _locale[9]="Select Language:\0\0";
  _locale[10]="english (builtin)\0\0";
  _locale[11]="Okay\0\0";
  _locale[12]="Welcome to Worker\0\0";
  _locale[13]="Bytes\0\0";
  _locale[14]="Color Count:\0\0";
  _locale[15]="Palette\0\0";
  _locale[16]="Filelister-Settings\0\0";
  _locale[17]="Nr. of Rows for Buttons:\0\0";
  _locale[18]="Nr. of Coloumns for Buttons:\0\0";
  _locale[19]="Left Lister\0\0";
  _locale[20]="Right Lister\0\0";
  _locale[21]="Horizontal Scroller:\0\0";
  _locale[22]="top:\0\0";
  _locale[23]="Height:\0\0";
  _locale[24]="Vertical Scroller:\0\0";
  _locale[25]="left:\0\0";
  _locale[26]="Width:\0\0";
  _locale[27]="Palette-Entry:\0\0";
  _locale[28]="Red:\0\0";
  _locale[29]="Green:\0\0";
  _locale[30]="Blue:\0\0";
  _locale[31]="Statusbar\0\0";
  _locale[32]="Foreground\0\0";
  _locale[33]="Background\0\0";
  _locale[34]="Selected ListView-Bar\0\0";
  _locale[35]="Unselected ListView-Bar\0\0";
  _locale[36]="unselected dir\0\0";
  _locale[37]="selected dir\0\0";
  _locale[38]="unselected file\0\0";
  _locale[39]="selected file\0\0";
  _locale[40]="path\0\0";
  _locale[41]="not selected:\0\0";
  _locale[42]="selected:\0\0";
  _locale[43]="clockbar\0\0";
  _locale[44]="Requester\0\0";
  _locale[45]="Choose Color:\0\0";
  _locale[46]="left Startup-Path:\0\0";
  _locale[47]="right Startup-Path:\0\0";
  _locale[48]="Copy Button\0\0";
  _locale[49]="Swap Button\0\0";
  _locale[50]="Delete Button\0\0";
  _locale[51]="left Mousebutton\0\0";
  _locale[52]="right Mousebutton\0\0";
  _locale[53]="Choose Button to edit or Choose Action\0\0";
  _locale[54]="Select Button to copy (or press ESC to cancel)\0\0";
  _locale[55]="Select Destination-Button (will be overwrited) (or press ESC to cancel)\0\0";
  _locale[56]="Select first Button to swap (or press ESC to cancel)\0\0";
  _locale[57]="Select second Button to swap (or press ESC to cancel)\0\0";
  _locale[58]="Select Button to delete (or press ESC to cancel)\0\0";
  _locale[59]="Edit Button\0\0";
  _locale[60]="Button Title:\0\0";
  _locale[61]="Choose Shortcut\0\0";
  _locale[62]="Delete Shortcut\0\0";
  _locale[63]="Commando\0\0";
  _locale[64]="Flags\0\0";
  _locale[65]="Enter own commando:\0\0";
  _locale[66]="Please press the key for the shortcut!\0\0";
  _locale[67]="Select Option:\0\0";
  _locale[68]="Bank-Nr.:\0\0";
  _locale[69]="next bank\0\0";
  _locale[70]="prev. bank\0\0";
  _locale[71]="new bank\0\0";
  _locale[72]="delete bank\0\0";
  _locale[73]="Copy path\0\0";
  _locale[74]="Swap path\0\0";
  _locale[75]="Delete path\0\0";
  _locale[76]="Choose path to edit or one of the action-Buttons\0\0";
  _locale[77]="Select path to copy (or press ESC to cancel)\0\0";
  _locale[78]="Select Destination-path (will be overwrited) (or press ESC to cancel)\0\0";
  _locale[79]="Select first path to swap (or press ESC to cancel)\0\0";
  _locale[80]="Select second path to swap (or press ESC to cancel)\0\0";
  _locale[81]="Select path to delete (or press ESC to cancel)\0\0";
  _locale[82]="Edit Path\0\0";
  _locale[83]="Path title:\0\0";
  _locale[84]="Enter path:\0\0";
  _locale[85]="New type\0\0";
  _locale[86]="Duplicate type\0\0";
  _locale[87]="Delete type\0\0";
  _locale[88]="Edit type\0\0";
  _locale[89]="Name:\0\0";
  _locale[90]="User-info:\0\0";
  _locale[91]="Hotkeys\0\0";
  _locale[92]="Hotkey-name:\0\0";
  _locale[93]="Pattern:\0\0";
  _locale[94]="Use Pattern\0\0";
  _locale[95]="Filecontent\0\0";
  _locale[96]="Use filecontent\0\0";
  _locale[97]="Byte\0\0";
  _locale[98]="Edit Byte\0\0";
  _locale[99]="Clear Byte\0\0";
  _locale[100]="Automatic creation\0\0";
  _locale[101]="Edit filecontent\0\0";
  _locale[102]="Enter code or press key\0\0";
  _locale[103]="File\0\0";
  _locale[104]="Error while creating configuration file\0\0";
  _locale[105]="Free RAM\0\0";
  _locale[106]="Free Swap\0\0";
  _locale[107]="Files\0\0";
  _locale[108]="Dirs\0\0";
  _locale[109]="Dir\0\0";
  _locale[110]="Symbolic link to dir\0\0";
  _locale[111]="Symbolic link to file\0\0";
  _locale[112]="not yet checked\0\0";
  _locale[113]="unknown type\0\0";
  _locale[114]="Quitting Worker\0\0";
  _locale[115]="Do you really wanna quit Worker\0\0";
  _locale[116]="Copy file %s\0\0";
  _locale[117]="to\0\0";
  _locale[118]="files to copy:\0\0";
  _locale[119]="dirs to copy:\0\0";
  _locale[120]="bytes copied\0\0";
  _locale[121]="Remaining time:\0\0";
  _locale[122]="Creating Database for copy-process\0\0";
  _locale[123]="Worker Request\0\0";
  _locale[124]="Worker Message\0\0";
  _locale[125]="Worker Warning\0\0";
  _locale[126]="Can't creating the directory %s\0\0";
  _locale[127]="All subfiles and subdirs are ignored\0\0";
  _locale[128]="Want create the directory %s\0\0";
  _locale[129]="but there is already a file named so!\0\0";
  _locale[130]="Should this file be erased?\0\0";
  _locale[131]="If not, so all subfiles und subdirs are ignored.\0\0";
  _locale[132]="Don't erase\0\0";
  _locale[133]="The file %s already exisits!\0\0";
  _locale[134]="Overwrite this file ?\0\0";
  _locale[135]="Overwrite all\0\0";
  _locale[136]="Overwrite none\0\0";
  _locale[137]="Don't overwrite\0\0";
  _locale[138]="Error while deleting file %s\0\0";
  _locale[139]="Sourcefile will be ignored\0\0";
  _locale[140]="Creating Database for deleting\0\0";
  _locale[141]="Deleting file %s\0\0";
  _locale[142]="remaining files:\0\0";
  _locale[143]="remaining dirs:\0\0";
  _locale[144]="Should all selected files be erased ?\0\0";
  _locale[145]="The selected dirs and files will be erased recursive (except links!)!\0\0";
  _locale[146]="Continue?\0\0";
  _locale[147]="Can't remove the directory %s!\0\0";
  _locale[148]="Enter new name for %s:\0\0";
  _locale[149]="Rename\0\0";
  _locale[150]="Please enter new name or cancel!\0\0";
  _locale[151]="Error while renaming!\0\0";
  _locale[152]="Enter name for directory:\0\0";
  _locale[153]="Error while moving!\0\0";
  _locale[154]="New Hotkey\0\0";
  _locale[155]="Duplicate Hotkey\0\0";
  _locale[156]="Delete Hotkey\0\0";
  _locale[157]="Edit Hotkey\0\0";
  _locale[158]="Sortmode\0\0";
  _locale[159]="Filter\0\0";
  _locale[160]="Name-Sort\0\0";
  _locale[161]="Size-Sort\0\0";
  _locale[162]="Access-Time\0\0";
  _locale[163]="Modification-Time\0\0";
  _locale[164]="Change-Time\0\0";
  _locale[165]="Reverse Sortorder\0\0";
  _locale[166]="Listingmode\0\0";
  _locale[167]="New Filter\0\0";
  _locale[168]="Edit Filter(s)\0\0";
  _locale[169]="Remove selected Filter(s)\0\0";
  _locale[170]="include\0\0";
  _locale[171]="exclude\0\0";
  _locale[172]="Edit Filter\0\0";
  _locale[173]="normal Filelister\0\0";
  _locale[174]="Informationmode\0\0";
  _locale[175]="no informations available\0\0";
  _locale[176]="Name\0\0";
  _locale[177]="Size\0\0";
  _locale[178]="Type\0\0";
  _locale[179]="Destination\0\0";
  _locale[180]="Permissions:\0\0";
  _locale[181]="User\0\0";
  _locale[182]="Group\0\0";
  _locale[183]="Other\0\0";
  _locale[184]="Owner\0\0";
  _locale[185]="Position\0\0";
  _locale[186]="real Position\0\0";
  _locale[187]="Free space\0\0";
  _locale[188]="of\0\0";
  _locale[189]="(right button for options)\0\0";
  _locale[190]="There is already a dir named %s\0\0";
  _locale[191]="Please type in a new name!\0\0";
  _locale[192]="Shall this be used ?\0\0";
  _locale[193]="I wasnt allowed to create the dir %s!\0\0";
  _locale[194]="On this write-protected Device nothing can be created!\0\0";
  _locale[195]="This filesystem doesn't support symlinks!\0\0";
  _locale[196]="the symlink %s couldn't be created!\0\0";
  _locale[197]="the device is full!\0\0";
  _locale[198]="permission denied on file\0\0";
  _locale[199]="Moving file %s\0\0";
  _locale[200]="Enter text:\0\0";
  _locale[201]="Press RETURN to continue!\0\0";
  _locale[202]="Enter additional arguments:\0\0";
  _locale[203]="Enter the pattern for selecting:\0\0";
  _locale[204]="Creating Database\0\0";
  _locale[205]="The symlink %s couldn't be created!\0\0";
  _locale[206]="Enter the destination of the symlink:\0\0";
  _locale[207]="Enter the name of the link:\0\0";
  _locale[208]="About Worker\0\0";
  _locale[209]="Font\0\0";
  _locale[210]="Enter Fontname:\0\0";
  _locale[211]="This font doesn't exists!\0\0";
  _locale[212]="Enter destination directory:\0\0";

  _localecoms[0]="owm commando\0\0";
  _localecoms[1]="Quit\0\0";
  _localecoms[2]="Copy\0\0";
  _localecoms[3]="Move\0\0";
  _localecoms[4]="Delete\0\0";
  _localecoms[5]="MakeDir\0\0";
  _localecoms[6]="Rename\0\0";
  _localecoms[7]="Select all\0\0";
  _localecoms[8]="Select none\0\0";
  _localecoms[9]="Invert selection\0\0";
  _localecoms[10]="Reload\0\0";
  _localecoms[11]="previous Item\0\0";
  _localecoms[12]="next Item\0\0";
  _localecoms[13]="Parent dir\0\0";
  _localecoms[14]="go in dir\0\0";
  _localecoms[15]="First Item\0\0";
  _localecoms[16]="Last Item\0\0";
  _localecoms[17]="Page Up\0\0";
  _localecoms[18]="Page Down\0\0";
  _localecoms[19]="Invert active item\0\0";
  _localecoms[20]="Main function\0\0";
  _localecoms[21]="Run program\0\0";
  _localecoms[22]="Change Lister options\0\0";
  _localecoms[23]="Scroll Lister to left\0\0";
  _localecoms[24]="Scroll Lister to right\0\0";
  _localecoms[25]="Filter select\0\0";
  _localecoms[26]="Dirsize\0\0";
  _localecoms[27]="Create Symlink\0\0";
  _localecoms[28]="Change Symlink\0\0";
  
  _localeflags[0]="Do all files\0\0";
  _localeflags[1]="No Safety-Request\0\0";
  _localeflags[2]="follow symbolic links\0\0";
  _localeflags[3]="overwrite existing files without request\0\0";
  _localeflags[4]="overwrite none files\0\0";
  _localeflags[5]="change destination filename\0\0";
  _localeflags[6]="Request these flags before copying\0\0";
  _localeflags[7]="overwrite existing files without request\0\0";
  _localeflags[8]="overwrite none files\0\0";
  _localeflags[9]="change destination filename\0\0";
  _localeflags[10]="Request these flags before moving\0\0";
  _localeflags[11]="run seperate with each entry\0\0";
  _localeflags[12]="with subdirs\0\0";
  _localeflags[13]="run in terminal\0\0";
  _localeflags[14]="run in terminal and wait for key\0\0";
  _localeflags[15]="show output\0\0";
  _localeflags[16]="filename with apostrophe\0\0";
  _localeflags[17]="update lister at finish\0\0";
  _localeflags[18]="update other lister at finish\0\0";
  _localeflags[19]="run in terminal\0\0";
  _localeflags[20]="run in terminal and wait for key\0\0";
  _localeflags[21]="show output\0\0";
  _localeflags[22]="global program\0\0";
  _localeflags[23]="Request these flags before executing\0\0";
  _localeflags[24]="left lister\0\0";
  _localeflags[25]="right lister\0\0";
  _localeflags[26]="create in the same directory\0\0";
  _localeflags[27]="local link\0\0";
  _localeflags[28]="Request these flags\0\0";
  
  _localeuflags[0]="first selected File without path\0\0";
  _localeuflags[1]="all selected Files without path\0\0";
  _localeuflags[2]="first selected File with path\0\0";
  _localeuflags[3]="all selected Files with path\0\0";
  _localeuflags[4]="first selected File without path (no unselect)\0\0";
  _localeuflags[5]="all selected Files without path (no unselect)\0\0";
  _localeuflags[6]="first selected File with path (no unselect)\0\0";
  _localeuflags[7]="all selected Files with path (no unselect)\0\0";
  _localeuflags[8]="first selected File without path, no Extension\0\0";
  _localeuflags[9]="all selected Files without path, no Extension\0\0";
  _localeuflags[10]="first selected File with path, no Extension\0\0";
  _localeuflags[11]="all selected Files with path, no Extension\0\0";
  _localeuflags[12]="first selected File without path (no unselect), no Extension\0\0";
  _localeuflags[13]="all selected Files without path (no unselect), no Extension\0\0";
  _localeuflags[14]="first selected File with path (no unselect), no Extension\0\0";
  _localeuflags[15]="all selected Files with path (no unselect), no Extension\0\0";
  _localeuflags[16]="path\0\0";
  _localeuflags[17]="other path\0\0";
  _localeuflags[18]="left path\0\0";
  _localeuflags[19]="right path\0\0";
  _localeuflags[20]="Request string\0\0";
  if(strcmp(_WConfig.lang,"english (builtin)")!=0) {
    actlang=(char*)_allocsafe(strlen(_WConfig.lang)+1);
    if(actlang!=NULL) strcpy(actlang,_WConfig.lang);
    file=(char*)_allocsafe(strlen(home)+9+1+strlen(_WConfig.lang)+8+7+1);
    if(file!=NULL) {
      strcpy(file,home);
      strcat(file,"/catalogs/");
      strcat(file,_WConfig.lang);
      strcat(file,".catalog");
      fp=fopen(file,"r");
      if(fp!=NULL) {
        for(x=0;x<_NML;x++) {
          if(fgets(buffer,2047,fp)!=NULL) {
            len=strlen(buffer);
            if(len>0) {
              if(buffer[len-1]==10) {
                tstr=(char*)_allocsafe(len+1);
                buffer[len-1]=0;
              } else {
                tstr=(char*)_allocsafe(len+1+1);
              }
              strcpy(tstr,buffer);
            } else {
              tstr=(char*)_allocsafe(len+1+1);
              strcpy(tstr,buffer);
            }
            tstr[strlen(tstr)+1]=1;
            _locale[x]=tstr;
          } else {
            printf("Wrong .catalog file, some of the strings will be english,\n");
            printf("Please redownload Worker to fix it!\n");
            break;
          }
        }
        fclose(fp);
        strcat(file,".coms");
        fp=fopen(file,"r");
        if(fp!=NULL) {
          for(x=0;x<COMNR;x++) {
            if(fgets(buffer,2047,fp)!=NULL) {
              len=strlen(buffer);
              if(len>0) {
                if(buffer[len-1]==10) {
                  tstr=(char*)_allocsafe(len+1);
                  buffer[len-1]=0;
                } else {
                  tstr=(char*)_allocsafe(len+1+1);
                }
                strcpy(tstr,buffer);
              } else {
                tstr=(char*)_allocsafe(len+1+1);
                strcpy(tstr,buffer);
              }
              tstr[strlen(tstr)+1]=1;
              _localecoms[x]=tstr;
            } else {
              printf("Wrong .catalog.coms file, some of the strings will be english,\n");
              printf("Please redownload Worker to fix it!\n");
              break;
            }
          }
          fclose(fp);
          strcpy(file,home);
          strcat(file,"/catalogs/");
          strcat(file,_WConfig.lang);
          strcat(file,".catalog.flags");
          fp=fopen(file,"r");
          if(fp!=NULL) {
            for(x=0;x<FLAGNR;x++) {
              if(fgets(buffer,2047,fp)!=NULL) {
                len=strlen(buffer);
                if(len>0) {
                  if(buffer[len-1]==10) {
                    tstr=(char*)_allocsafe(len+1);
                    buffer[len-1]=0;
                  } else {
                    tstr=(char*)_allocsafe(len+1+1);
                  }
                  strcpy(tstr,buffer);
                } else {
                  tstr=(char*)_allocsafe(len+1+1);
                  strcpy(tstr,buffer);
                }
                tstr[strlen(tstr)+1]=1;
                _localeflags[x]=tstr;
              } else {
                printf("Wrong .catalog.flags file, some of the strings will be english,\n");
                printf("Please redownload Worker to fix it!\n");
                break;
              }
            }
            fclose(fp);            
            strcpy(file,home);
            strcat(file,"/catalogs/");
            strcat(file,_WConfig.lang);
            strcat(file,".catalog.uflags");
            fp=fopen(file,"r");
            if(fp!=NULL) {
              for(x=0;x<UFLAGNR;x++) {
                if(fgets(buffer,2047,fp)!=NULL) {
                  len=strlen(buffer);
                  if(len>0) {
                    if(buffer[len-1]==10) {
                      tstr=(char*)_allocsafe(len+1);
                      buffer[len-1]=0;
                    } else {
                      tstr=(char*)_allocsafe(len+1+1);
                    }
                    strcpy(tstr,buffer);
                  } else {
                    tstr=(char*)_allocsafe(len+1+1);
                    strcpy(tstr,buffer);
                  }
                  tstr[strlen(tstr)+1]=1;
                  _localeuflags[x]=tstr;
                } else {
                  printf("Wrong .catalog.uflags file, some of the strings will be english,\n");
                  printf("Please redownload Worker to fix it!\n");
                  break;
                }
              }
              fclose(fp);
            }
          }
        }
      }
      _freesafe(file);
    }
  }
}

void _FreeLanguage()
{
  int x;
  char *tstr;
  if(actlang!=NULL) {
    _freesafe(actlang);
  }
  for(x=0;x<_NML;x++) {
    tstr=_locale[x];
    if(tstr[strlen(tstr)+1]==1) _freesafe(_locale[x]);
  }
  for(x=0;x<COMNR;x++) {
    tstr=_localecoms[x];
    if(tstr[strlen(tstr)+1]==1) _freesafe(_localecoms[x]);
  }
  for(x=0;x<FLAGNR;x++) {
    tstr=_localeflags[x];
    if(tstr[strlen(tstr)+1]==1) _freesafe(_localeflags[x]);
  }
  for(x=0;x<UFLAGNR;x++) {
    tstr=_localeuflags[x];
    if(tstr[strlen(tstr)+1]==1) _freesafe(_localeuflags[x]);
  }
}

void _FreeConfig()
{
  struct _filetypedef *tempft,*tempft1;
  _freesafe(_WConfig.lang);
  _freesafe(_WConfig.ldir);
  _freesafe(_WConfig.rdir);
  _freesafe(_WConfig.font);
  _FreeAllConfigColor();
  _FreeAllConfigButton();
  _FreeAllConfigPath();
  _FreeAllHotkeys();
  tempft=_WConfig.firsttype;
  while(tempft!=NULL) {
    tempft1=tempft->next;
    _FreeFiletype(tempft);
    tempft=tempft1;
  }
  _WConfig.firsttype=NULL;
}

