#include "infomode.h"

extern _GfxWin *mainwin;
extern _MainStruct mainstruct;
extern char *_locale[];

void _IM_on(int nr)
{
  int mode;
  struct _button *lvb;
  char *str;
  void (*off)(int);
  mode=mainstruct.lister[nr].activemode;  /* derzeitigen Modus lesen */
  if(mode==1) return;
  if(mode>=0) {                            /* sonst ausschalten */
    off=mainstruct.mode_info[mode].off;
    if(off!=NULL) (*off)(nr);
  }
  _IM_Update(nr);
  if(nr==mainstruct._ActiveLV) _IM_activate();
  mainstruct.lister[nr].activemode=1;
  mainstruct.lister[nr].lv->sel_proc=NULL;
  lvb=mainstruct.lister[nr].lvb;
  str=(char*)_allocsafe(strlen(mainstruct.mode_info[1].name)+3+strlen(_locale[189])+1);
  sprintf(str,"%s - %s",mainstruct.mode_info[1].name,_locale[189]);
  _freesafe(lvb->text_normal);
  lvb->text_normal=str;
  _RedrawWin(mainwin);
}

void _IM_off(int nr)
{
  _ListView *lv;
  _ListViewContent *lvc;
  struct _button *lvb;
  char *str;
  if(nr==mainstruct._ActiveLV) _IM_deactivate();
  lv=mainstruct.lister[nr].lv;  
  lvc=lv->first;
  while(lvc!=NULL) {
    _RemoveListViewContent(mainwin,lv,lvc);
    lvc=lv->first;
  }
  mainstruct.lister[nr].activemode=-1;
  lv->sel_proc=NULL;
  lvb=mainstruct.lister[nr].lvb;
  str=(char*)_allocsafe(1);
  str[0]=0;
  _freesafe(lvb->text_normal);
  lvb->text_normal=str;
  _RedrawWin(mainwin);
}

void _IM_activate(void)
{
  _Button *lvb;
  _SolidButton *statebar;
  int nr;
  int fg,bg;

  nr=mainstruct._ActiveLV;
  lvb=mainstruct.lister[nr].lvb;
  statebar=mainstruct.statebar;
  fg=_WConfig.sel_lvbfg;
  bg=_WConfig.sel_lvbbg;
  lvb->fg_normal=fg;
  lvb->bg_normal=bg;
  _RedrawWin(mainwin);
}

void _IM_deactivate(void)
{
  _Button *lvb;
  _SolidButton *statebar;
  int nr;
  int fg,bg;

  nr=mainstruct._ActiveLV;
  lvb=mainstruct.lister[nr].lvb;
  statebar=mainstruct.statebar;
  fg=_WConfig.unsel_lvbfg;
  bg=_WConfig.unsel_lvbbg;
  lvb->fg_normal=fg;
  lvb->bg_normal=bg;
  _freesafe(statebar->text);
  statebar->text=(char*)_allocsafe(1);
  statebar->text[0]=0;
  _RedrawWin(mainwin);
}

void _IM_Shutdown(void)
{
  _IMInfo *imi;
  imi=(_IMInfo*)mainstruct.mode_info[1].special_info;
  _freesafe(imi);
  mainstruct.mode_info[1].special_info=NULL;
}

void _IM_Update(int nr)
{
  _IMInfo *imi;
  imi=(_IMInfo*)mainstruct.mode_info[1].special_info;
  imi->update[nr]=TRUE;
}

void _IM_ShowInfo(void *fileinfo)
{
  _FileEntry *fe;
  _ListView *lv;
  _ListViewContent *lvc,*last;
  _IMInfo *imf;
  int mode,nr,onr,x,len,len2;
  char buffer[1024],buffer2[MAXPATHLEN],buffer3[10],linkdest[2048],rights[3][4],*str;
  bool showno,goon,subinfo;
  unsigned long size,freespace;
  float percent;
  struct tm *timeptr;
  struct group *gruppe;
  struct passwd *user;
#ifdef LINUX
  struct statfs fsstatistic;
#else
  struct statvfs fsstatistic;
#endif
  _RealLister *rl;
  
  if(mainstruct.lister[0].activemode==1) {
    nr=0;
    onr=1;
    mode=mainstruct.lister[1].activemode;
  } else if(mainstruct.lister[1].activemode==1) {
    nr=1;
    onr=0;
    mode=mainstruct.lister[0].activemode;
  } else {
    /* kein Lister auf Modus 1 ?! */
    return;
  }
  if(mode==1) return;      /* beide Lister auf Mode 1 */
  imf=(_IMInfo*)mainstruct.mode_info[1].special_info;
  /* vvv Prfen, ob Inhalt erneuert werden mu vvv */
  goon=TRUE;
  if((imf->update[nr]==FALSE)&&(imf->finished[nr]==TRUE)) goon=FALSE;
  if(mode==0) {
    /* fr normalen Modus */
    fe=(_FileEntry*)fileinfo;
    if(fe!=NULL) {
      if(imf->filenr[nr]!=fe->nr) goon=TRUE;
    } else {
      if(imf->filenr[nr]>=0) {
        /* gerade wird eine Information angezeigt, jedoch ist jetzt keine Element mehr
           aktiv, also wenigstens "keine Informationen erhltlich" anzeigen */
        imf->filenr[nr]=-2;
        goon=TRUE;
      }
    }
  }
  if(imf->lastmode[nr]!=mode) goon=TRUE;
  /* ^^^ es wurde gecheckt, ob Modus seit letztem Aufruf gendert worden ist ^^^
     ^^^ und ob ein anderes Element angewhlt worden ist ^^^ */
  if(goon==FALSE) return;
  lv=mainstruct.lister[nr].lv;  
  lvc=lv->first;
  while(lvc!=NULL) {
    _RemoveListViewContent(mainwin,lv,lvc);
    lvc=lv->first;
  }
  last=NULL;

  showno=TRUE;
  if(mode==0) {
    /* fr normalen Modus */
    fe=(_FileEntry*)fileinfo;
    if(fe!=NULL) {
      rl=(_RealLister*)mainstruct.mode_info[0].special_info;
      showno=FALSE;
      imf->filenr[nr]=fe->nr;
      last=_AddListViewContent(lv,last,"",-1);
      sprintf(buffer,"%s: %s",_locale[176],fe->name);
      last=_AddListViewContent(lv,last,buffer,-1);
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        if(fe->dirsize>=0) size=fe->dirsize;
        else {
          if(fe->islink==TRUE) {
            size=fe->lsize;
          } else {
            size=fe->size;
          }          
        }
      } else {
        if(fe->islink==TRUE) {
          size=fe->lsize;
        } else {
          size=fe->size;
        }
      }
      sprintf(buffer,"%s: %ld B, %ld KB, %ld MB",_locale[177],size,(size+512)/1024,(size+524288)/1048576);
      last=_AddListViewContent(lv,last,buffer,-1);
      subinfo=FALSE;
      if(S_ISDIR(fe->mode)) {
        if(fe->islink==TRUE) {
          sprintf(buffer,"%s: %s",_locale[178],_locale[110]);
          x=readlink(fe->fullname,linkdest,2047);
          if(x>=0) {
            linkdest[x]=0;
            sprintf(buffer2,"  %s: %s",_locale[179],linkdest);
            subinfo=TRUE;
          }
        } else {
          sprintf(buffer,"%s: %s",_locale[178],_locale[109]);
        }          
      } else {
        if(fe->islink==TRUE) {
          sprintf(buffer,"%s: %s",_locale[178],_locale[111]);
          x=readlink(fe->fullname,linkdest,2047);
          if(x>=0) {
            linkdest[x]=0;
            sprintf(buffer2,"  %s: %s",_locale[179],linkdest);
            subinfo=TRUE;
          }
        } else {
          if(fe->filetypeindex==-2) {
            sprintf(buffer,"%s: %s",_locale[178],_locale[112]);
          } else if(fe->filetypeindex==-1) {
            sprintf(buffer,"%s: %s",_locale[178],_locale[113]);
          } else {
            if(fe->filetype!=NULL) {
              sprintf(buffer,"%s: %s",_locale[178],fe->filetype->name);
            } else {
              sprintf(buffer,"%s: ???",_locale[178]);
            }
          }
        }
      }
      last=_AddListViewContent(lv,last,buffer,-1);
      if(subinfo==TRUE) {
        last=_AddListViewContent(lv,last,buffer2,-1);
      }
      if(fe->islink==TRUE) {
        if((fe->lmode&S_IRUSR)==S_IRUSR) strcpy(rights[0],"r"); else strcpy(rights[0],"-");
        if((fe->lmode&S_IWUSR)==S_IWUSR) strcat(rights[0],"w"); else strcat(rights[0],"-");
        if((fe->lmode&S_IXUSR)==S_IXUSR) strcat(rights[0],"x"); else strcat(rights[0],"-");
        if((fe->lmode&S_IRGRP)==S_IRGRP) strcpy(rights[1],"r"); else strcpy(rights[1],"-");
        if((fe->lmode&S_IWGRP)==S_IWGRP) strcat(rights[1],"w"); else strcat(rights[1],"-");
        if((fe->lmode&S_IXGRP)==S_IXGRP) strcat(rights[1],"x"); else strcat(rights[1],"-");
        if((fe->lmode&S_IROTH)==S_IROTH) strcpy(rights[2],"r"); else strcpy(rights[2],"-");
        if((fe->lmode&S_IWOTH)==S_IWOTH) strcat(rights[2],"w"); else strcat(rights[2],"-");
        if((fe->lmode&S_IXOTH)==S_IXOTH) strcat(rights[2],"x"); else strcat(rights[2],"-");
      } else {
        if((fe->mode&S_IRUSR)==S_IRUSR) strcpy(rights[0],"r"); else strcpy(rights[0],"-");
        if((fe->mode&S_IWUSR)==S_IWUSR) strcat(rights[0],"w"); else strcat(rights[0],"-");
        if((fe->mode&S_IXUSR)==S_IXUSR) strcat(rights[0],"x"); else strcat(rights[0],"-");
        if((fe->mode&S_IRGRP)==S_IRGRP) strcpy(rights[1],"r"); else strcpy(rights[1],"-");
        if((fe->mode&S_IWGRP)==S_IWGRP) strcat(rights[1],"w"); else strcat(rights[1],"-");
        if((fe->mode&S_IXGRP)==S_IXGRP) strcat(rights[1],"x"); else strcat(rights[1],"-");
        if((fe->mode&S_IROTH)==S_IROTH) strcpy(rights[2],"r"); else strcpy(rights[2],"-");
        if((fe->mode&S_IWOTH)==S_IWOTH) strcat(rights[2],"w"); else strcat(rights[2],"-");
        if((fe->mode&S_IXOTH)==S_IXOTH) strcat(rights[2],"x"); else strcat(rights[2],"-");
      }
      len=strlen(_locale[180]);
      len2=strlen(_locale[181]);
      for(x=1;x<3;x++) if(strlen(_locale[181+x])>len2) len2=strlen(_locale[181+x]);
      sprintf(buffer2,"%%%ds %%%ds: %%s",len,len2);
      sprintf(buffer,buffer2,_locale[180],_locale[181],rights[0]);
      last=_AddListViewContent(lv,last,buffer,-1);
      sprintf(buffer,buffer2,"",_locale[182],rights[1]);
      last=_AddListViewContent(lv,last,buffer,-1);
      sprintf(buffer,buffer2,"",_locale[183],rights[2]);
      last=_AddListViewContent(lv,last,buffer,-1);

      if(fe->islink==TRUE) {
        gruppe=getgrgid(fe->lgroupid);
      } else {
        gruppe=getgrgid(fe->groupid);
      }
      if(fe->islink==TRUE) {
        user=getpwuid(fe->luserid);
      } else {
        user=getpwuid(fe->userid);
      }
      sprintf(buffer,"%s: ",_locale[184]);
      if(user!=NULL) {
        sprintf(buffer2,"%s @ ",user->pw_name);
        /* TODO: vielleicht free(user);*/
      } else {
        sprintf(buffer2,"??? @ ");
      }
      strcat(buffer,buffer2);
      if(gruppe!=NULL) {
        sprintf(buffer2,"%s",gruppe->gr_name);
        /* TODO: vielleicht free(gruppe);*/
      } else {
        sprintf(buffer2,"???");
      }
      strcat(buffer,buffer2);
      last=_AddListViewContent(lv,last,buffer,-1);

      len=strlen(_locale[162]);
      for(x=1;x<3;x++) if(strlen(_locale[162+x])>len) len=strlen(_locale[162+x]);
      if(fe->islink==TRUE) {
        timeptr=localtime(&(fe->llastaccess));
      } else {
        timeptr=localtime(&(fe->lastaccess));
      }          
      str=asctime(timeptr);
      str[strlen(str)-1]=0;
      sprintf(buffer2,"%%%ds: %%s",len);
      sprintf(buffer,buffer2,_locale[162],str);
      last=_AddListViewContent(lv,last,buffer,-1);
      if(fe->islink==TRUE) {
        timeptr=localtime(&(fe->llastmod));
      } else {
        timeptr=localtime(&(fe->lastmod));
      }          
      str=asctime(timeptr);
      str[strlen(str)-1]=0;
      sprintf(buffer,buffer2,_locale[163],str);
      last=_AddListViewContent(lv,last,buffer,-1);
      if(fe->islink==TRUE) {
        timeptr=localtime(&(fe->llastchange));
      } else {
        timeptr=localtime(&(fe->lastchange));
      }          
      str=asctime(timeptr);
      str[strlen(str)-1]=0;
      sprintf(buffer,buffer2,_locale[164],str);
      last=_AddListViewContent(lv,last,buffer,-1);

      sprintf(buffer,"%s: %s",_locale[185],fe->fullname);
      last=_AddListViewContent(lv,last,buffer,-1);

      if(realpath(fe->fullname,buffer2)!=NULL) {
        sprintf(buffer,"%s: %s",_locale[186],buffer2);
      } else {
        sprintf(buffer,"%s: ???",_locale[186]);
      }
      last=_AddListViewContent(lv,last,buffer,-1);
      last=_AddListViewContent(lv,last,"",-1);
#ifdef LINUX
      if(statfs(rl->Dir[onr],&fsstatistic)==0) {
        freespace=fsstatistic.f_bavail*fsstatistic.f_bsize;
        size=fsstatistic.f_blocks*fsstatistic.f_bsize;
#else
      if(statvfs(rl->Dir[onr],&fsstatistic)==0) {
        freespace=fsstatistic.f_bavail*fsstatistic.f_frsize;
        size=fsstatistic.f_blocks*fsstatistic.f_frsize;
#endif
        if(size>0) {
          percent=(float)(freespace)*100/size+.5;
        } else {
          percent=0.0;
        }
        if(size>10485760) {
          size+=524288;
          size/=1048576;
          strcpy(buffer3,"MB");
        } else if(size>10240) {
          size+=512;
          size/=1024;
          strcpy(buffer3,"KB");
        } else {
          strcpy(buffer3,"B");
        }
        if(freespace>10485760) {
          freespace+=524288;
          freespace/=1048576;
          strcpy(buffer2,"MB");
        } else if(freespace>10240) {
          freespace+=512;
          freespace/=1024;
          strcpy(buffer2,"KB");
        } else {
          strcpy(buffer2,"B");
        }
        sprintf(buffer,"%s: %ld %s (%2.0f %%) %s %ld %s",_locale[187],freespace,buffer2,percent,_locale[188],size,buffer3);
      } else {
        sprintf(buffer,"%s: ???",_locale[187]);
      }
      last=_AddListViewContent(lv,last,buffer,-1);
    }
  }
  if(showno==TRUE) {
    /* fr alle anderen sind keine Informationen erhltlich */
    last=_AddListViewContent(lv,last,"",-1);
    last=_AddListViewContent(lv,last,"",-1);
    last=_AddListViewContent(lv,last,_locale[175],-1);
  }
  lvc=lv->first;
  while(lvc!=NULL) {
    lvc->fg_select=lvc->fg_normal;
    lvc->bg_select=lvc->bg_normal;
    lvc=lvc->next;
  }
  imf->update[nr]=FALSE;
  imf->finished[nr]=TRUE;
  imf->lastmode[nr]=mode;
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

